//
// Copyright (c) 2000 by the University of Southern California
// All rights reserved.
//
// Permission to use, copy, modify, and distribute this software and its
// documentation in source and binary forms for non-commercial purposes
// and without fee is hereby granted, provided that the above copyright
// notice appear in all copies and that both the copyright notice and
// this permission notice appear in supporting documentation. and that
// any documentation, advertising materials, and other materials related
// to such distribution and use acknowledge that the software was
// developed by the University of Southern California, Information
// Sciences Institute.  The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
//
// THE UNIVERSITY OF SOUTHERN CALIFORNIA makes no representations about
// the suitability of this software for any purpose.  THIS SOFTWARE IS
// PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// Other copyrights might apply to parts of this software and are so
// noted when applicable.
//
// $Header: /nfs/jade/vint/CVSROOT/nam-1/enetmodel.h,v 1.7 2000/03/24 03:49:04 haoboy Exp $
//
// Network model for Editor

#ifndef nam_enetmodel_h
#define nam_enetmodel_h

#include "netmodel.h"

// The ratio of node radius and mean edge length in the topology

class EditorNetModel : public NetModel {
public:
	EditorNetModel(const char *animator);
	virtual ~EditorNetModel();
	void BoundingBox(BBox&);

	int addNode(float cx, float cy);
	int addLink(Node*, Node*);
	int addAgent(Node*, char*, float, float);
        int addAgentLink(Agent*, Agent*);

	int saveAsEnam(const char*);
	int saveAsNs(const char*);

	void setNodeProperty(int,char*,int);
        void setAgentProperty(int,char*,int);
	void setLinkProperty(int,int,char*,int);
	void layout();

	void removeLink(Edge *);
	void removeNode(Node *);
	void removeAgent(Agent *a);

	inline EditorNetModel* wobj() { return wobj_; }
protected:
	EditorNetModel *wobj_;
	int command(int argc, const char*const* argv);


private:
	int nID;
	double  pxmin_;
        double  pymin_;
	double  pxmax_;
        double  pymax_;

};


#endif // nam_enetmodel_h
